float4x4 matProjection;

texture tex0;
sampler2D normalb = 
sampler_state
{
	texture = (tex0);
	AddressU = Wrap;
	AddressV = Wrap; 
	MipFilter = Linear; MagFilter = Linear; MinFilter = Linear;
};

void vs_lightning(in float4 ipos : POSITION,
				  in float2 itex : TEXCOORD0,
				  out float4 opos : POSITION,
				  out float2 otex : TExCOORD0)
{
	opos = mul(ipos, matProjection);
	otex = itex;
};

float4 ps_lightning(in float2 tex : TEXCOORD0) : COLOR0
{
	return tex2D(normalb, tex);
};

technique lightning
{
	pass base
	{
		VertexShader = compile vs_2_0 vs_lightning();
		PixelShader  = compile ps_2_0 ps_lightning();
	}
};
